<img src="https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/atearlogo.png" align="Center">
<br>
## AtEar
AtEar is a scalable and efficient system, and also the first web-based wireless vulnerability assessment solution. <br>
This Wireless Vulnerability Analysis/Management Solution, AtEar, can be utilized both by businesses and in the home.  <br>
For business use, AtEar utilizes fingerprint devices for access to the  network and to analyze the current wireless network conditions. <br>The automatic penetration testing function makes it possible to analyze wireless vulnerability conveniently and meticulously. <br>AtEar for home networks inspects network security conditions and monitors for any unregistered devices.  <br>

# Intro

> In short, [AtEar](http://www.norma.co.kr) is a wireless pentest system.<br>
> AtEar provides a web-based user interface.<br>
> AtEar is easy and fast to use.<br>

![alt AtEar_Product] (https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/AtEar_Product.jpg)
<h3>Is your company’s wireless network secure?<br>
AtEar helps keep your wireless network safe from hackers and intruders.<br></h3>
<br>

### Operation Video
<a href="https://www.youtube.com/embed/qkqEirRf88E"> Operation Video Link</a>
<br>
### AtEar Features
1. Wireless Scanning(Ad-Hoc, Station, Access Point, Soft-Acess Point)
2. Wireless Chart(Channel, Encryption, Type)
3. Wireless Pentesting(WEP, WPA1, WPA2)
4. Network Information Getting(IP, Connected Host Info)
5. Fake AP
  - Google Phishing Sites
  - Facebook Phishing Sites
  - Twitter Phishing Sites
6. WIDS(Wireless intrusion detection system)
  - Disassocation Flood
  - Deauth Flood
  - WESSID-NG Attack
  - Koreck Chopchop attack
  - Fragmentation PGRA Attack
  - MDK MICHEAL SHUTDOWN Exploitation TKIP Attack
  - Attack By TKIPUN-NG
  - Authentication DOS Attack
  - Assocation Flood
  - High Amount of Assocation Sent
  - Suspect Rouge AP
  - Detected Beacon Flood

These features will be released this month.<br>
<b>Network Pentesting</b><br>
  - FTP Brute Force
  - SSH Brute Force
  - Telnet Brute Force
  - SMTP Brute Force
  - POP Brute Force
  - IMAP Brute Force
  - LDAP Brute Force
  - SMB Brute Force
  - rlogin Brute Force
  - MSSQL Brute Force
  - MYSQL Brute Force
  - PGSQL Brute Force
  - VNC Brute Force
  - SNMP Brute Force

### Most recommended systems
`Developed by Ubuntu 14.04 LTS(amd64) and python 2.7v`

### Most recommended USB Lancards
***It will aircrack-ng supoorted USB-Lancard***<br>
`asus WL-167g v2`<br>
`Airlink AWLL3026`<br>
`Alfa AWUS036E`<br>
`Alfa AWUS036G`<br>
`Alfa AWUS036S`<br>
`Alfa AWUS050NH`<br>
`Digitus DN-7003GS`<br>
`D-Link DWL-G122 B1`<br>
`D-Link DWL-G122 C1`<br>
`D-Link WUA-1340`<br>
`Edimax EW-7318USg`<br>
`Hawking HWUG1`<br>
`Linksys WUSB54G v4`<br>
`Linksys WUSB54GC v1`<br>
`Linksys WUSB54GC v2`<br>
`Netgear WG111 v1`<br>
`Netgear WG111 v2`<br>
`Netgear WG111 v3`<br>
`Netgear WNDA3100 v1`<br>
`TP-Link TL-WN321G`<br>
`TP-Link TL-WN321G v4`<br>
`Trendnet TEW-429UB C1`<br>
`ZyXEL AG-225H`<br>
`ZyXEL G-202`<br>

### Dependency Programs
`aircrack-ng`<br>
`tshark`<br>
`hostapd`<br>
`python-dev`<br>
`python-flask`<br>
`python-paramiko`<br>
`python-psycopg2`<br>
`python-pyodbc`<br>
`python-sqlite`<br>
`python-pip`<br>

### AtEar Installation Instructions
Clone a copy of the main AtEar git repo by running:<br>
`sudo apt-get install git`<br>
`git clone https://github.com/NORMA-Inc/AtEar.git`<br>
Enter the AtEar directory and run the install script:<br>
`cd ./AtEar/`<br>
`sudo bash install.sh`<br>

### How to Run
`cd ./AtEar/`<br>
`sudo python run.py --iface wlan* <br>
`Open Web Browsers`<br>
`127.0.0.1:8080`<br>

### AtEar Customers
<img src="https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/Samsung.png" width="350">
<img src="https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/KoreaTelecom.png" width="350">
<img src="https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/police1.png" width="350">
<img src="https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/edu1.png" width="350">
<img src="https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/korea_rail.png" width="350">
<img src="https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/Ministry_en.png" width="350">
<img src="https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/kgu.png" width="350">
<img src="https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/koreauniversity.png" width="350">
<img src="https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/kbs.png" width="350">
<img src="https://raw.githubusercontent.com/NORMA-Inc/AtEar/master/product_img/kaits_.png" width="350">

### Reference
AtEar’s flexible and convenient functionality can overcome the limitations of WIPS. <br>
This achievement has led to partnerships with telecommunications companies SAMSUNG and KT. Many other small and middle-sized businesses and public institutions have chosen AtEar as their favorite wireless security solution thanks to its user friendliness and competitive cost. Satisfied customers include prominent institutions such as the Seoul City Hall, the Korea Rail Network Authority and Korea University. <br>

### AtEar-Demo Add-on Features
1. A database for a particular sector of a wireless device can be specified.
2. The demo program can provide the latest Access Point Firmware Database.
3. The program has some project management capabilities.
4. The program can provide a function report.<br>
***AtEar-Demo is a free 30-Day Trial Version***

### Requesting the AtEar-Demo Version
[NORMA-Inc Homepage](http://www.norma.co.kr)<br>
Contact us [contact@norma.co.kr](mailto:contact@norma.co.kr)
